Index: code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- code/trunk/src/orxonox/LevelManager.cc	(revision 5980)
+++ code/trunk/src/orxonox/LevelManager.cc	(revision 6021)
@@ -32,5 +32,5 @@
 #include <OgreResourceGroupManager.h>
 
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
@@ -53,7 +53,7 @@
 
         // check override
-        if (!CommandLine::getArgument("level")->hasDefaultValue())
+        if (!CommandLineParser::getArgument("level")->hasDefaultValue())
         {
-            ModifyConfigValue(defaultLevelName_, tset, CommandLine::getValue("level").getString());
+            ModifyConfigValue(defaultLevelName_, tset, CommandLineParser::getValue("level").getString());
         }
     }
Index: code/trunk/src/orxonox/Main.cc
===================================================================
--- code/trunk/src/orxonox/Main.cc	(revision 5980)
+++ code/trunk/src/orxonox/Main.cc	(revision 6021)
@@ -36,5 +36,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/Game.h"
 #include "core/LuaState.h"
@@ -76,15 +76,15 @@
 
         // Some development hacks (not really, but in the future, this calls won't make sense anymore)
-        if (CommandLine::getValue("standalone").getBool())
+        if (CommandLineParser::getValue("standalone").getBool())
             Game::getInstance().requestStates("graphics, standalone, level");
-        else if (CommandLine::getValue("server").getBool())
+        else if (CommandLineParser::getValue("server").getBool())
             Game::getInstance().requestStates("graphics, server, level");
-        else if (CommandLine::getValue("client").getBool())
+        else if (CommandLineParser::getValue("client").getBool())
             Game::getInstance().requestStates("graphics, client, level");
-        else if (CommandLine::getValue("dedicated").getBool())
+        else if (CommandLineParser::getValue("dedicated").getBool())
             Game::getInstance().requestStates("dedicated, level");
-        else if (CommandLine::getValue("dedicatedClient").getBool())
+        else if (CommandLineParser::getValue("dedicatedClient").getBool())
             Game::getInstance().requestStates("dedicatedClient, level");
-        else if (CommandLine::getValue("console").getBool())
+        else if (CommandLineParser::getValue("console").getBool())
             Game::getInstance().requestStates("ioConsole");
         else
Index: code/trunk/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 5980)
+++ code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 6021)
@@ -31,5 +31,5 @@
 #include "util/Clock.h"
 #include "util/Exception.h"
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/Game.h"
 #include "core/GameMode.h"
@@ -56,5 +56,5 @@
         GameMode::setIsClient(true);
 
-        this->client_ = new Client(CommandLine::getValue("ip").getString(), CommandLine::getValue("port"));
+        this->client_ = new Client(CommandLineParser::getValue("ip").getString(), CommandLineParser::getValue("port"));
 
         if(!client_->establishConnection())
Index: code/trunk/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 5980)
+++ code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 6021)
@@ -36,5 +36,5 @@
 #include "util/Debug.h"
 #include "util/Sleep.h"
-#include "core/CommandLine.h"
+#include "core/CommandLineParse.h"
 #include "core/CommandExecutor.h"
 #include "core/Game.h"
@@ -81,5 +81,5 @@
 #endif
 
-        this->server_ = new Server(CommandLine::getValue("port"));
+        this->server_ = new Server(CommandLineParser::getValue("port"));
         COUT(0) << "Loading scene in server mode" << std::endl;
 
@@ -91,5 +91,5 @@
         this->server_->close();
         delete this->server_;
-        
+
         closeThread_ = true;
 #ifdef ORXONOX_PLATFORM_UNIX
@@ -138,5 +138,5 @@
                         escapeChar = 2;
                         continue;
-                    }
+}
                     else if ( escapeChar == 2 )
                     {
Index: code/trunk/src/orxonox/gamestates/GSDedicatedClient.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSDedicatedClient.cc	(revision 5980)
+++ code/trunk/src/orxonox/gamestates/GSDedicatedClient.cc	(revision 6021)
@@ -37,5 +37,5 @@
 #include "util/Exception.h"
 #include "util/Sleep.h"
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/CommandExecutor.h"
 #include "core/Game.h"
@@ -80,5 +80,5 @@
 #endif
 
-        this->client_ = new Client(CommandLine::getValue("ip").getString(), CommandLine::getValue("port"));
+        this->client_ = new Client(CommandLineParser::getValue("ip").getString(), CommandLine::getValue("port"));
         COUT(0) << "Loading scene in client mode" << std::endl;
 
@@ -93,10 +93,10 @@
     void GSDedicatedClient::deactivate()
     {
-        if( this->client_ )
+        if (this->client_)
         {
             this->client_->closeConnection();
             delete this->client_;
         }
-        
+
         closeThread_ = true;
 #ifdef ORXONOX_PLATFORM_UNIX
@@ -143,5 +143,5 @@
                         escapeChar = 2;
                         continue;
-                    }
+}
                     else if ( escapeChar == 2 )
                     {
Index: code/trunk/src/orxonox/gamestates/GSServer.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSServer.cc	(revision 5980)
+++ code/trunk/src/orxonox/gamestates/GSServer.cc	(revision 6021)
@@ -30,5 +30,5 @@
 
 #include "util/Debug.h"
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/Game.h"
 #include "core/GameMode.h"
@@ -55,5 +55,5 @@
         GameMode::setHasServer(true);
 
-        this->server_ = new Server(CommandLine::getValue("port"));
+        this->server_ = new Server(CommandLineParser::getValue("port"));
         COUT(0) << "Loading scene in server mode" << std::endl;
 