Index: trunk/src/lib/graphics/spatial_separation/quadtree.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 5819)
+++ trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 6022)
@@ -12,5 +12,5 @@
 
 #include "base_object.h"
-#include "abstract_model.h"
+#include "model.h"
 
 
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 5819)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 6022)
@@ -21,5 +21,5 @@
 #include "quadtree.h"
 #include "material.h"
-#include "abstract_model.h"
+#include "model.h"
 #include "debug.h"
 
@@ -346,5 +346,5 @@
 /**
  *  gets the maximal dimension of a model
- * @return the dimension of the AbstractModel as a Rectangle
+ * @return the dimension of the Model as a Rectangle
 
    The rectangle is x-z axis aligned. ATTENTION: if there are any vertices in the model, that exceed the
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 5819)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 6022)
@@ -17,5 +17,5 @@
 #include "base_object.h"
 
-#include "abstract_model.h"
+#include "model.h"
 
 // FORWARD DECLARATION
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 5819)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 6022)
@@ -18,5 +18,5 @@
 #include "spatial_separation.h"
 
-#include "abstract_model.h"
+#include "model.h"
 #include "quadtree.h"
 #include "debug.h"
@@ -34,5 +34,5 @@
 
  */
-SpatialSeparation::SpatialSeparation (AbstractModel* model, float overlapSize)
+SpatialSeparation::SpatialSeparation (Model* model, float overlapSize)
 {
   PRINT(3)("+---------Debug Information SpatialSeparation----------\n");
@@ -52,5 +52,5 @@
    The boxes are overlaping because this makes collision detection a lot simpler
  */
-SpatialSeparation::SpatialSeparation (AbstractModel* model, AbstractModel* playerModel)
+SpatialSeparation::SpatialSeparation (Model* model, Model* playerModel)
 {
   this->setClassID(CL_SPATIAL_SEPARATION, "SpatialSeparation");
@@ -75,5 +75,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model, float minLength)
+Quadtree* SpatialSeparation::createQuadtree(Model* model, float minLength)
 {
   this->minLength = minLength;
@@ -88,5 +88,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model, int treeDepth)
+Quadtree* SpatialSeparation::createQuadtree(Model* model, int treeDepth)
 {
   this->treeDepth = treeDepth;
@@ -100,5 +100,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model)
+Quadtree* SpatialSeparation::createQuadtree(Model* model)
 {
   this->quadtree = new Quadtree(model->getModelInfo(), 4);
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 5819)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 6022)
@@ -9,5 +9,5 @@
 
 
-class AbstractModel;
+class Model;
 class Quadtree;
 
@@ -21,6 +21,6 @@
 
   public:
-    SpatialSeparation(AbstractModel* model, float overlapSize);
-    SpatialSeparation(AbstractModel* model, AbstractModel* playerModel);
+    SpatialSeparation(Model* model, float overlapSize);
+    SpatialSeparation(Model* model, Model* playerModel);
     virtual ~SpatialSeparation();
 
@@ -28,7 +28,7 @@
     void setMinLength(int minLength) { this->minLength = minLength; }
 
-    Quadtree* createQuadtree(AbstractModel* model, float minLength);
-    Quadtree* createQuadtree(AbstractModel* model, int treeDepth);
-    Quadtree* createQuadtree(AbstractModel* model);
+    Quadtree* createQuadtree(Model* model, float minLength);
+    Quadtree* createQuadtree(Model* model, int treeDepth);
+    Quadtree* createQuadtree(Model* model);
 
     inline Quadtree* getQuadtree() { return this->quadtree; }
@@ -41,8 +41,8 @@
 
   private:
-    AbstractModel*             model;        //!< the reference to the model that has to be handled
+    Model*             model;        //!< the reference to the model that has to be handled
     Quadtree*                  quadtree;     //!< the reference to the created quadtree
 
-    AbstractModel*             playerModel;  //!< referece to the player model, if needed for overlap calculations
+    Model*             playerModel;  //!< referece to the player model, if needed for overlap calculations
     float                      overlapSize;  //!< the size of overlaping
 