Index: data/trunk/AUTHORS
===================================================================
--- data/trunk/AUTHORS	(revision 6002)
+++ data/trunk/AUTHORS	(revision 6027)
@@ -9,6 +9,4 @@
 audio/ambient/tha_silent_partner_-_void.ogg                 unknown
 audio/sounds/laser1.wav                                     unknown
-defaultConfigs/keybindings.ini                              Reto Grieder
-defaultConfigs/masterKeybingings.ini                        Reto Grieder
 fonts/bluebold.ttf                                          unknown
 fonts/bluecond.ttf                                          unknown
@@ -35,10 +33,4 @@
 fonts/VeraMono.fontdef                                      unknown
 fonts/VeraMono.ttf                                          unknown
-gui/configs/CEGUIConfig.xsd                                 unknown
-gui/configs/Falagard.xsd                                    unknown
-gui/configs/Font.xsd                                        unknown
-gui/configs/GUIScheme.xsd                                   Benjamin Knecht
-gui/configs/GUILayout.xsd                                   unknown
-gui/configs/Imageset.xsd                                    unknown
 gui/fonts/bluehigh.ttf                                      http://www.iconian.com/
 gui/fonts/bluehighway-10.font                               http://www.iconian.com/
@@ -72,86 +64,8 @@
 gui/imagesets/WindowsLook.imageset                          unknown
 gui/imagesets/WindowsLook.tga                               Paul "CrazyEddie" Turner
-gui/layouts/cegui8.layout                                   unknown
-gui/layouts/CompositorDemo.layout                           unknown
-gui/layouts/Console.wnd                                     unknown
-gui/layouts/CrowdDemo.layout                                unknown
-gui/layouts/Demo7Windows.layout                             unknown
-gui/layouts/Demo8.layout                                    unknown
-gui/layouts/DragDropDemo.layout                             unknown
-gui/layouts/facial.layout                                   unknown
-gui/layouts/FontDemo.layout                                 unknown
-gui/layouts/GUILayout.xsd                                   unknown
-gui/layouts/InGameTest.layout                               Benjamin Knecht
-gui/layouts/InstancingDemo.layout                           unknown
-gui/layouts/MainMenu_2.layout                               Benjamin Knecht
-gui/layouts/MainMenu.layout                                 Reto Grieder
-gui/layouts/ogregui.layout                                  unknown
-gui/layouts/PickupInventory.layout                          Daniel 'Huty' Haggenmüller
-gui/layouts/shadows.layout                                  unknown
-gui/layouts/TabControlDemo.layout                           unknown
-gui/layouts/TabPage1.layout                                 unknown
-gui/layouts/TabPage2.layout                                 unknown
-gui/layouts/TabPage.layout                                  unknown
-gui/layouts/TextDemo.layout                                 unknown
-gui/layouts/TreeDemoTaharez.layout                          unknown
-gui/layouts/VanillaConsole.layout                           unknown
-gui/layouts/VanillaWindows.layout                           unknown
 gui/looknfeel/Falagard.xsd                                  unknown
 gui/looknfeel/TaharezLook.looknfeel                         unknown
 gui/looknfeel/Vanilla.looknfeel                             unknown
 gui/looknfeel/WindowsLook.looknfeel                         unknown
-gui/schemes/Demo8.scheme                                    unknown
-gui/schemes/GUIScheme.xsd                                   unknown
-gui/schemes/OrxonoxGUIScheme.scheme                         Benjamin Knecht
-gui/schemes/TaharezLook.scheme                              unknown
-gui/schemes/TaharezLookSkin.scheme                          unknown
-gui/schemes/TaharezLookWidgetAliases.scheme                 unknown
-gui/schemes/TaharezLookWidgets.scheme                       unknown
-gui/schemes/VanillaSkin.scheme                              unknown
-gui/schemes/WindowsLook.scheme                              unknown
-gui/schemes/WindowsLookWidgets.scheme                       unknown
-gui/scripts/demo8.lua                                       unknown
-gui/scripts/gui.lua                                         unknown
-gui/scripts/IConsole.lua                                    unknown
-gui/scripts/inGameTest.lua                                  Benjamin Knecht
-gui/scripts/InstancedInit.lua                               unknown
-gui/scripts/loadGUI_2.lua                                   Benjamin Knecht
-gui/scripts/loadGUI_3.lua                                   Benjamin Knecht
-gui/scripts/loadGUI.lua                                     Reto Grieder, Benjamin Knecht
-gui/scripts/mainmenu_2.lua                                  Benjamin Knecht
-gui/scripts/mainmenu.lua                                    Reto Grieder
-gui/scripts/PickupInventory.lua                             Daniel 'Huty' Haggenmüller
-levels/empty_level.oxw                                      Felix Schulthess, Fabian 'x3n' Landau
-levels/gametype_asteroids.oxw                               Aurelian Jaggi
-levels/gametype_underattack.oxw                             Matthias Mock
-levels/pickuptest.oxw                                       Daniel 'Huty' Haggenmüller
-levels/presentation09b.oxw                                  Fabian 'x3n' Landau, Benjamin Knecht
-levels/presentation09.oxw                                   Benjamin Knecht
-levels/presentation_dm.oxw                                  Fabian 'x3n' Landau
-levels/presentation.oxw                                     Reto Grieder, Fabian 'x3n' Landau
-levels/presentation_pong.oxw                                Fabian 'x3n' Landau
-levels/teambasematchlevel.oxw                               Val Mikos
-levels/teamdeatchmatch.oxw                                  Fabian 'x3n' Landau
-levels/tutorial.oxw                                         Fabian 'x3n' Landau
-levels/waypoints.oxw                                        Fabian 'x3n' Landau
-levels/includes/CuboidSpaceStation.lua                      Mirko Kaiser
-levels/includes/weaponsettings1.oxi                         Fabian 'x3n' Landau
-levels/includes/weaponsettings2.oxi                         Fabian 'x3n' Landau
-levels/includes/weaponsettings3.oxi                         Joël Smely, Fabian 'x3n' Landau, Oli Scheuss
-levels/includes/weaponsettings_H2.oxi                       Fabian 'x3n' Landau
-levels/includes/weaponsettings_pirate.oxi                   Fabian 'x3n' Landau
-levels/old/CuboidSpaceStation.oxw                           Mirko Kaiser
-levels/old/physicstest2.oxw                                 Reto Grieder
-levels/old/physicstest.oxw                                  Reto Grider, Martin Stypinski
-levels/old/planettest.oxw                                   Felix Schulthess
-levels/old/presentation_physics.oxw                         Reto Grider, Fabian 'x3n' Landau
-levels/old/princessaeryn.oxw                                Damian Frick
-levels/old/questsystem.oxw                                  Damian Frick
-levels/old/sample4.oxw                                      Martin Polak, Fabian 'x3n' Landau
-levels/old/spaceshiptemplates_physics.oxw                   Reto Grieder
-levels/old/tutorial_hs08.oxw                                Reto Grieder
-levels/templates/spaceship_assff.oxt                        Fabian 'x3n' Landau
-levels/templates/spaceship_H2.oxt                           Fabian 'x3n' Landau
-levels/templates/spaceship_pirate.oxt                       Fabian 'x3n' Landau
 materials/programs/AmbientOneTexture.glsl                   unknown
 materials/programs/Blur0_ps20.hlsl                          unknown                    